import { EventEmitter, OnInit } from '@angular/core';
import { MatPaginator, MatDialog, MatSnackBar, MatSort } from '@angular/material';
import { DataSource } from '@angular/cdk/collections';
import { Observable } from 'rxjs/Observable';
import 'rxjs/add/observable/of';
import 'rxjs/add/observable/merge';
import 'rxjs/add/operator/map';
import { BehaviorSubject } from 'rxjs/BehaviorSubject';
import { Headers, Http, RequestOptions } from '@angular/http';
export declare class ObjectCrudComponent implements OnInit {
    private http;
    dialog: MatDialog;
    snackBar: MatSnackBar;
    dataSource: ApiDataSource;
    show_warning: any;
    length: Observable<number>;
    window_message: string;
    field: boolean;
    search_keyword: string;
    columns_def: string[];
    headers: Headers;
    options: RequestOptions;
    paginator: MatPaginator;
    sorter: MatSort;
    displayed_columns: Array<{
        label: string;
        field_name: string;
        type: string;
        visible: boolean;
        editable: boolean;
    }>;
    labels: string[];
    model_name: string;
    baseApiUrl: string;
    urlSegments: any[];
    search_field_changed: EventEmitter<any>;
    constructor(http: Http, dialog: MatDialog, snackBar: MatSnackBar);
    ngOnInit(): void;
    getObjectFeed(): Promise<void>;
    private reloadColumnVisibility();
    changeColumnVisibility(colName: string): void;
    addEditObject(element: any[]): void;
    searchFieldChanged(value: any): void;
    getCount(obj: string): Observable<any>;
}
export declare class ApiDataSource extends DataSource<any> {
    private http;
    private paginator;
    private sorter;
    private model_name;
    private baseApiUrl;
    private urlSegments;
    private search_field_changed;
    private options;
    dataLoad: BehaviorSubject<any>;
    sort_direction: string;
    order_by: string;
    constructor(http: Http, paginator: MatPaginator, sorter: MatSort, model_name: string, baseApiUrl: string, urlSegments: string[], search_field_changed: EventEmitter<any>, options: RequestOptions);
    filterFeed(obj: string, category: any[], keyword: string, limit: number, selected_page: number, sort: string, order_by: string): any;
    connect(): Observable<any>;
    disconnect(): void;
}
